Package org.codehaus.groovy.control.messages

# Record Class Diagnostic

java.lang.Object
java.lang.Record
org.codehaus.groovy.control.messages.Diagnostic

Record Components:
  `file` - the source unit name, or `null` when the message has none
  `line` - the 1-based line, or `-1` when the message has no position
  `column` - the 1-based column, or `-1` when unknown
  `text` - the message text, which may span several lines

public record Diagnostic(String file, int line, int column, String text) extends Record
A format-neutral view of a `Message`: what it says and, when known, the source and position it applies to. `ErrorFormat` renders its non-default layouts from this, so a new layout needs no change to the message classes (GROOVY-12312).

Since:
  6.0.0

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Diagnostic(String file, int line, int column, String text)`
  Creates an instance of a `Diagnostic` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `column()`
  Returns the value of the `column` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `String`
  `file()`
  Returns the value of the `file` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `int`
  `line()`
  Returns the value of the `line` record component.
  `String`
  `text()`
  Returns the value of the `text` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Diagnostic

    public Diagnostic(String file, int line, int column, String text)
    Creates an instance of a `Diagnostic` record class.
    Parameters:
      `file` - the value for the `file` record component
      `line` - the value for the `line` record component
      `column` - the value for the `column` record component
      `text` - the value for the `text` record component

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### file

    public String file()
    Returns the value of the `file` record component.
    Returns:
      the value of the `file` record component

  - ### line

    public int line()
    Returns the value of the `line` record component.
    Returns:
      the value of the `line` record component

  - ### column

    public int column()
    Returns the value of the `column` record component.
    Returns:
      the value of the `column` record component

  - ### text

    public String text()
    Returns the value of the `text` record component.
    Returns:
      the value of the `text` record component